// ---------------------------------------------------------------------------
// whatsit :	Shared Memory Arena 
// author  :	Terry Franguiadakis : code lifted from jonGoldman via Caro.cruz
// usage   :	create only one ShareMemArena make shure it in the master 
//		process. To guarentee otherwise would complicate this code.
//		
// ---------------------------------------------------------------------------
#ifndef SHAREDMEMORYARENA_TFSD__H
#define SHAREDMEMORYARENA_TFSD__H

// definition of a CAVEShareMemory for the faint at heart.
#define NewCAVEUserSharedMemory(var, amount)     SharedMemArena \
        memory(CAVEUserSharedMemory, (amount));                 \
        (var) = SharedMemArena::getArena();			\
	SharedMemArena::on();


#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <ulocks.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <time.h>
#include <malloc.h>
#include <bstring.h>

// --------------------------------------------------------------------
// usefull inlines 
// -------------------------------------------------------------------- 
inline int megs(int i )		{ return (i * 1024 * 1024 ); }
// --------------------------------------------------------------------
// --------------------------------------------------------------------

class SharedMemArena {
    public:
	SharedMemArena();
	SharedMemArena( size_t size );
	SharedMemArena(void *(*)(int), size_t );
	~SharedMemArena();
	
	static void perror(char *);
	static void init(size_t size);
	static void load_arena( void *ar, int sz );
	static void on(void);
	static void off(void);
	
	static char *adres ;
	
	static void *malloc( size_t t ) ;
	static void  free( void *p ) ;  

	static int  amount (void);
        static void reset  (void);
	static void* getArena (void);
	
	static int flag ;		// share or not 
    protected:
	static char *name ;
	static usptr_t *Arena ;
	static void *arena ;
	static int did_it;
	static int size , freestore ;
	static int __amount;	
};

// --------------------------------------------------------------------
inline 
void SharedMemArena::on(void) { SharedMemArena::flag  = 1 ; }
// ---
inline
void SharedMemArena::off(void) { SharedMemArena::flag  = 0 ; }

inline void* SharedMemArena::getArena (void) { return arena; }
// --------------------------------------------------------------------

#endif
