// $Header: /afs/fl.mcs.anl.gov/usr/cave/hudson/V_Squared/OpenGL/inc/RCS/BBox.h,v 1.6 1995/10/08 18:57:00 hudson Exp hudson $


#pragma once


#if defined(MY_EXT)	//	Not my extensions; my off-ONYX copy of the patch154 extensions
#include "GL/gl.h"
//	#include "GL/glu.h"
#else
#include <GL/gl.h>
//	#include <GL/glu.h>
#endif
#include "Obj.h"
#include "Shape.h"


class BBox : public Obj, public Shape {
protected:
	GLfloat bounds[3][2];	//	+/- Bounds in X, Y, Z directions
	GLfloat ctr[3];
	GLfloat extents[3];
	GLfloat vtcs[8][3];		//	Vertices
	//      Octants:
	//                                           
	//               y                            
	//                                           
	//               ^                            
	//               |                            
	//               |                            
	//               |                            
	//           7  -|-  6                        
	//           .   +   .                       
	//       4 - - - - - - - 5                    
	//           .       .    -----> x                    
	//       |   3 - - - 2   |                    
	//                                            
	//       | /     +     \ |                      
	//               |                            
	//       0 - - - | - - - 1                    
	//               |                            
	//               v                            
	//               z                            
	//                                           
	//                                           

	GLfloat width;	//	line width
public:
	BBox();
	~BBox();

	//	Access func's
	GLfloat* Bounds(GLint i);
	GLfloat*& SetBounds(GLint i);
	GLfloat* GetVtcs(GLint i);
	GLfloat* Ctr();
	GLfloat*& SetCtr();
	GLfloat* GetExtents();
	void LoadExtents();

	void LoadVtcs();
	void Draw();
	void GraphicsInit();
	void Cpl_DrawList();	//	Compile drawing DispList
};
