//	$Header: /afs/fl.mcs.anl.gov/usr/cave/hudson/V_Squared/OpenGL/inc/RCS/Reg3dScalField.h,v 1.10 1996/05/06 22:05:30 hudson Exp $


#pragma once


#if defined(MY_EXT)	//	Not my extensions; my off-ONYX copy of the patch154 extensions
#include "GL/gl.h"
#else
#include <GL/gl.h>
#endif
#include "Indata.h"
#include "Outdata.h"


class Reg3dScalField : public Indata, public Outdata {
protected:
	int elem_size;
	char *elem_type;
	float x_vox_size;	//	X extent of 1 voxel
	float y_vox_size;	//	Y extent of 1 voxel
	float z_vox_size;	//	Z extent of 1 voxel
	GLfloat loval;
	GLfloat hival;

	//	Need these instead of x,y,zres and extent, because can't assume that the pixel,
	//	esp. in a single, 3d, input file, are stored in the file such that
	//	x's have the shortest stride, y the next shortest, and z the longest
	GLint minor_res;	//	# pixels in direction of shortest stride (usually x)
	GLint middle_res;	//	# pixels in direction of middle stride (usually y)
	GLint major_res;	//	# pixels in direction of longest stride (usually z)
	float minor_extent;	//	extent of entire volume in dir. of shortest stride
	float middle_extent;	//	as above
	float major_extent;	//	as above
	GLfloat diagonal;		//	diagonal of minor_extent*middle_extent*major_extent field

	//	SEEMS THIS SHOULD BE PART OF MODEL, N'EST PAS?
	int subsample_factor;
public:
	Reg3dScalField(size_t aSize);
	~Reg3dScalField();

	float GetMINextent();
	float& SetMINextent();
	float GetMIDextent();
	float& SetMIDextent();
	float GetMAJextent();
	float& SetMAJextent();

	virtual void ComputeRange() = 0;	//	Compute lo and hi data val's
	GLfloat GetLoval();
	GLfloat GetHival();
	GLfloat& SetLoval();
	GLfloat& SetHival();

	int GetMINres();
	int GetMIDres();
	int GetMAJres();
	GLfloat GetDiagonal();

	int GetElem_size();

	int GetSubsample_factor();
	char *GetElem_type();
//	float *Grad(int x, int y, int z);
	void ComputeVoxSize();
	void ComputeDiagonal();
};
