//	$Header: /afs/fl.mcs.anl.gov/usr/cave/hudson/C++/OpenGL/include/RCS/Shape.h,v 1.5 1995/08/03 22:31:23 hudson Exp $


//	Shape is to be used as a base class.  Several specific shapes can be
//	derived from Shape -- Mysphere's (objectification of GL spheres,
//	Obj's (objectification of GL Objects) and Vlist's (vertex lists), so far.
//	Space contains a LIST of Shape pointers so the list can be a heterogeneous
//	one of these different specific shapes.


#pragma once


#include <GL/gl.h>


class	Shape {
protected:
	/* OGLXXX XXX fix this. */
	float	location[4];	//	GLfloat * of x-lation of shape frame w.r.t. space frame
	/* OGLXXX XXX fix this. */
	float	orientation[4];//	GLfloat * of rotation of shape frame w.r.t. space frame
	/* OGLXXX XXX fix this. */
	float	size[4];	//	GLfloat * of scaling of shape frame w.r.t. space frame
	float color[4];
public:
	Shape();
	~Shape();
	virtual float Loc(int i);
	virtual float& SetLoc(int i);
	virtual float Orient(int i);
	virtual float& SetOrient(int i);
	virtual float Size(int i);
	virtual float& SetSize(int i);
	virtual float Color(int i);
	virtual float& SetColor(int i);
	virtual void Draw() = 0;
};
