//	$Header: /afs/fl.mcs.anl.gov/usr/cave/hudson/C++/OpenGL/include/RCS/VRen.h,v 1.11 1996/06/24 22:07:54 hudson Exp $

#pragma once

#include "Texture3d.h"
#include "CAVE.h"
//	#include "hmatrix.h"
#include "Reg3dScalField.h"

struct ParmStruct {
	GLint major_res, middle_res, minor_res; // more generic than x-, y-, and z-res
	GLint res_factor;	//	for sub-sampling
	GLfloat major_extent, middle_extent, minor_extent; // more generic than x-, y-, and z-extent
	char elem_type[10];	//	'ushort', 'uchar', 'float'
	char data_name[100];	//	unique name for data, for developer's purposes
	int tex_megs;		//	# megs in tex ram on current machine, since can't directly determine the blasted amount!
};

class VRen {
private:
	//	---------- DATA ----------
	Model *aModel;
	Texture3d *aTexture3d;
	Reg3dScalField *aReg3dScalField;
	CAVE *aCAVE;
	GLint major_res, middle_res, minor_res; // more generic than x-, y-, and z-res
	GLint res_factor;	//	for sub-sampling
	GLfloat major_extent, middle_extent, minor_extent; // more generic than x-, y-, and z-extent
	char elem_type[10];	//	'ushort', 'uchar', 'float'
	char data_name[100];	//	unique name for data, for developer's purposes
	int tex_megs;		//	# megs in tex ram on current machine, since can't directly determine the blasted amount!
	int num_polys;			//	# of polygons slicing the texture volume
	CAVELOCK lut_lock;	//	To lock read/write of user-defined color lookup table
	CAVELOCK texturerot_lock;	//	To lock read/write of texture-rotation matrix
	CAVELOCK slicerotparms_lock;	//	To lock read/write of slice-stack-rotation angle and axis
	CAVELOCK numpolys_lock;	//	To lock read/write of user-defined number of slicing polygons
                        	//	the upper left 3x3 submatrix of the inverse of the calling app's mtx
	GLfloat OldHeadVec[16];	//	Loaded w/ old head loc & old head front vec (@ in turn) so they can be xformed by calling app's mtx

	//	---------- FUNCTIONS ----------
//	GLvoid ProcessParmfile(char * parmfile);	//	Turn on later
	GLvoid ProcessParmStruct(ParmStruct *parms);
	GLvoid MoveHeadToVolSpace(GLfloat *mtx, GLfloat *rotmtx, Head *oldHead, Head *newHead);

protected:
public:
	VRen(void *ImageArray, ParmStruct *parms, int aNum_polys = 175, ulong256_t lut = NULL);
	~VRen();
	GLvoid Draw();
	GLvoid InitApplication();
	GLvoid CalcFrame();
	GLvoid FrameApplication(GLfloat *mtx);	//	the user uses mtx to xform the origin-centered,
		                                    //	unscaled, axis-aligned volume however he wants
	GLvoid LoadUserLUT(ulong_t *lut);
	GLvoid SetNumPolys(int aNum_polys);
};
